Bug 1826935 - aclocal: error: too many loops
Summary: aclocal: error: too many loops
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: autoconf-archive
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: David King
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1835638
TreeView+ depends on / blocked
 
Reported: 2020-04-22 19:29 UTC by Jaroslav Škarvada
Modified: 2020-11-24 15:18 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1835638 (view as bug list)
Environment:
Last Closed: 2020-11-24 15:18:22 UTC
Type: Bug


Attachments (Terms of Use)
Reproducer (1.83 KB, application/gzip)
2020-04-22 19:29 UTC, Jaroslav Škarvada
no flags Details

Description Jaroslav Škarvada 2020-04-22 19:29:14 UTC
Created attachment 1680973 [details]
Reproducer

Description of problem:
PowerTOP recently (in v2.12) switched to autoconf-archive and it is not possible to build it now.

Version-Release number of selected component (if applicable):
autoconf-archive-2019.01.06-4.fc31.noarch

How reproducible:
Always

Steps to Reproduce:
1. dnf install automake libtool gettext-devel autoconf-archive
2. autoreconf -fi
3.

Actual results:
aclocal: installing 'm4/pkg.m4' from '/usr/share/aclocal/pkg.m4'
aclocal: installing 'm4/ax_require_defined.m4' from '/usr/share/aclocal/ax_require_defined.m4'
aclocal: error: too many loops
aclocal: Please contact <bug-automake>.
 at /usr/share/automake-1.16/Automake/Channels.pm line 662.
	Automake::Channels::msg("automake", "", "too many loops") called at /usr/share/automake-1.16/Automake/ChannelDefs.pm line 212
	Automake::ChannelDefs::prog_error("too many loops") called at /usr/bin/aclocal line 1195
autoreconf: aclocal failed with exit status: 255

Expected results:
No too many loops error

Additional info:
Very strange that running the autoreconf twice workarounds the problem, i.e.:
autoreconf -fi || autoreconf -fi

It could be also problem in the autotools or the configure.ac.

Comment 1 Jaroslav Škarvada 2020-04-22 19:49:43 UTC
Just dropping the
AX_ADD_FORTIFY_SOURCE
AX_PTHREAD

from the configure.ac and uninstalling the autoconf-archive, no "too many loops" error is reproduced. Then after reinstalling the autoconf-archive the error is reproduced again even without the AX_ macros.

Comment 2 Jaroslav Škarvada 2020-04-22 19:55:59 UTC
Also reproducible in the rawhide.
In the rawhide:
automake-1.16.1-14.fc32.noarch
gettext-devel-0.20.2-1.fc33.x86_64
libtool-2.4.6-33.fc32.x86_64
autoconf-archive-2019.01.06-5.fc32.noarch

Comment 3 David King 2020-05-14 10:27:09 UTC
Probably adding something along the lines of:

AX_REQUIRE_DEFINED([AX_ADD_FORTIFY_SOURCE])
AX_REQUIRE_DEFINED([AX_PTHREAD])

to the configure.ac of powertop would fix this. Additionally, as the error message comes from aclocal, and explicitly mentions reporting the bug to the automake mailing list, have you done so?

Running autoreconf twice fixes the problem because multiple dependent macros from autoconf-archive need to be copied by aclocal, which fails at some point during the copying process, which then succeeds the second time, as several of the required macros have already been copied by that point. This does not seem like an autoconf-archive bug per se, but due to an internal limit of aclocal when copying macros.

Comment 4 Jaroslav Škarvada 2020-05-14 11:25:07 UTC
(In reply to David King from comment #3)
Thanks for reply.

> Probably adding something along the lines of:
> 
> AX_REQUIRE_DEFINED([AX_ADD_FORTIFY_SOURCE])
> AX_REQUIRE_DEFINED([AX_PTHREAD])
> 
This seems to workaround the problem.

> to the configure.ac of powertop would fix this. Additionally, as the error
> message comes from aclocal, and explicitly mentions reporting the bug to the
> automake mailing list, have you done so?
>
I checked various similar reports in upstream and they usually closed it as macro problem. Unfortunately, I don't know much (and don't want to know :) about autotools, so that's why I started downstream. Because of comment 1, I reported it against autoconf-archive.

> Running autoreconf twice fixes the problem because multiple dependent macros
> from autoconf-archive need to be copied by aclocal, which fails at some
> point during the copying process, which then succeeds the second time, as
> several of the required macros have already been copied by that point. This
> does not seem like an autoconf-archive bug per se, but due to an internal
> limit of aclocal when copying macros.
>
Feel free to reassign to automake if you think the problem is there - I don't know the internals.

Comment 5 Ben Cotton 2020-11-03 16:38:28 UTC
This message is a reminder that Fedora 31 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 31 on 2020-11-24.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '31'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 31 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 6 Ben Cotton 2020-11-24 15:18:22 UTC
Fedora 31 changed to end-of-life (EOL) status on 2020-11-24. Fedora 31 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.